#!/bin/sh

set -e -x

HGPLAIN=
HGUSER=test
export HGPLAIN HGUSER

hg init issue2428
cd issue2428

cat <<EOF > .hg/hgrc
[defaults]
commit = -d "0 0"
[extensions]
mq =
EOF

touch toto
hg add toto
hg commit -m"add toto"
touch tata
hg add tata
hg commit -m"add tata"
hg up 0
touch titi
hg add titi
hg commit -m"add titi"
hg phase -p tip
#hg log -G --debug

{
    # load _phasecache.phaseroots
    printf 'runcommand\n\0\0\0\011phase\0-r1'
    sleep 1  # flush

    hg strip -r1 >&2  # by another process or thread

    # calls repo.invalidate() but _phasecache not cleared
    printf 'runcommand\n\0\0\0\010branches'
} | hg serve --cmdserver pipe --trace
