﻿using System;
using System.ComponentModel.DataAnnotations;
using Models.Metadata;

namespace Models
{
    [MetadataType(typeof(DepartmentMetadata))]
    public class Department
    {       
		public int UID { get; set; }
	
        public DateTime EffectiveDate { get; set; }
        public DateTime? EndDate { get; set; }

		public string CampusCode { get; set; }
        public virtual Person DepartmentHead { get; set; }
        public string DeptCode { get; set; }
        public string SubDeptCode { get; set; }
        public string DeptName { get; set; }
        public string MailCode { get; set; }
        public virtual ExecutiveLevel ExecLevel { get; set; }
        public virtual Division Division { get; set; }
        public virtual SchoolCollege SchoolCollege { get; set; }
        public bool OffCampus { get; private set; }
        public string BudgetSortDeptNumber { get; set; }

        public virtual Person PropertyContact { get; set; }
        public string BuildingNumber { get; set; }
        public string BuildingCampus { get; set; }
        public string Room { get; set; }
        public string GroupCode { get; set; }
        public string OtherLocation { get; set; }

        public bool FRS { get; set; }
        public bool EPA { get; set; }
        public bool DBR { get; private set; }
        public bool DCR { get; private set; }
        public bool FFX { get; set; }
        public bool TDP { get; private set; }
        public bool PurchasingTransFlag { get; private set; }
        public bool CenterInstitute { get; set; }
        public bool Surplus { get; private set; }

        public string DeptOffice { get; set; }
        public string DeptView { get; set; }
        public string ExecOffice { get; set; }
    }
}
