#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "album.h"
#include "auth.h"
#include "lastfm.h"
#include "buylink_private.h"
#include "shouts_private.h"

#include "helper/list.h"

/*    album.addTags     */
/*    album.getBuylinks */
/*    album.getInfo     */
/*    album.getShouts   */
/*    album.getTags     */
/*    album.getTopTags  */
/*    album.removeTag   */
/*    album.search      */
/*    album.share       */

LASTFM_BUYLINKS *album_getBuyLinks(const char *artist,
                                   const char *album,
                                   const char *mbid,
                                   const char *country,
                                   const bool autocorrect,
                                   LASTFM_AUTH *auth)
{
    return getBuyLinks(artist, album, NULL, mbid, country, autocorrect, auth, PAGE_ALBUM);
}

LASTFM_SHOUTS *album_getShouts(const char *artist,
                               const char *album,
                               const char *mbid,
                               const unsigned int page,
                               const unsigned int limit,
                               const bool autocorrect,
                               LASTFM_AUTH *auth)
{
    return getShouts(NULL, artist, album, NULL, mbid, NULL, page, limit, autocorrect, auth, PAGE_ALBUM);
}
