#ifndef _AUTH_H
#define _AUTH_H

#include <stdbool.h>

typedef struct LASTFM_SESSION LASTFM_SESSION;
typedef struct LASTFM_AUTH LASTFM_AUTH;

struct LASTFM_SESSION {
    char *key;
    char *name;
    bool subscriber;
};

struct LASTFM_AUTH {
    char *api_key;
    char *secret;
    char *token;
    LASTFM_SESSION *session;
};

LASTFM_AUTH *lastfm_auth_new(char *api_key, char *secret);
void lastfm_auth_delete(LASTFM_AUTH *auth);
char *lastfm_auth_getToken(const LASTFM_AUTH *auth);
LASTFM_SESSION *lastfm_auth_getSession(const LASTFM_AUTH *auth);
char *lastfm_auth_getUrl(const LASTFM_AUTH *auth);

#endif
