#ifndef _BUYLINK_H
#define _BUYLINK_H

#include <stdbool.h>

#include "helper/list.h"

typedef enum LASTFM_BUYLINK_TYPE LASTFM_BUYLINK_TYPE;
typedef struct LASTFM_BUYLINKS LASTFM_BUYLINKS;
typedef struct LASTFM_BUYLINK LASTFM_BUYLINK;
typedef struct LASTFM_PRICE LASTFM_PRICE;

enum LASTFM_BUYLINK_TYPE {
    LASTFM_BUYLINK_PHYSICAL,
    LASTFM_BUYLINK_DOWNLOAD
};

struct LASTFM_BUYLINKS {
    LIST *physicals;
    LIST *downloads;
};

struct LASTFM_BUYLINK {
    LASTFM_BUYLINK_TYPE type;
    const char *supplierName;
    LASTFM_PRICE *price;
    const char *buyLink;
    const char *supplierIcon;
    bool isSearch;
};

struct LASTFM_PRICE {
    const char *currency;
    double amount;
    const char *formatted;
};

void lastfm_buylinks_delete(LASTFM_BUYLINKS *buylinks);

#endif
