#ifndef _LIST_H
#define _LIST_H

#include <stdbool.h>
#include <stdlib.h>

typedef struct LIST LIST;
typedef void (*list_free_handler_t)(void *element);
typedef int (*list_sort_handler_t)(const void *element1, const void *element2);

struct LIST {
    list_free_handler_t free_handler;
    size_t size;
    void **elements;
};

LIST *list_new(void);
void list_delete(LIST *list);
void list_insert(LIST *list, const size_t at, const void *element);
void list_add(const LIST *list, const void *element);
void list_remove_at(LIST *list, const size_t at);
void list_remove(const LIST *list, const void *element);
void list_sort(const LIST *list, list_sort_handler_t sort_handler);

#endif
