#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <lastfm.h>
#include <auth.h>
#include <album.h>
#include <shouts.h>

#include <helper/md5.c>

int main(void)
{
    LASTFM_AUTH *auth;
    LASTFM_BUYLINKS *buylinks;
    LASTFM_SHOUTS *shouts;
    size_t i;
    char scanfc;
    
    lastfm_init();
    auth = lastfm_auth_new("b07bfe5accc130311e9256ae3bd6d67c", "88ea86c8bbbece2613d99744ab1fc9cc");
    auth->token = lastfm_auth_getToken(auth);
    printf("Authentication URL: %s\n", lastfm_auth_getUrl(auth));
    scanf("%c", &scanfc);
    auth->session = lastfm_auth_getSession(auth);
    
    if(auth->session != NULL)
    {
        printf("username = %s\nkey = %s\nsubscriber = %s\n\n", auth->session->name, auth->session->key, auth->session->subscriber ? "true" : "false");
    }
    
    buylinks = album_getBuyLinks("Kansas", "Kansas", NULL, "United Kingdom", false, auth);
    for(i = 0; i < buylinks->physicals->size + buylinks->downloads->size; ++i)
    {
        LASTFM_BUYLINK *buylink;
        
        if(i < buylinks->physicals->size)
        {
            buylink = (LASTFM_BUYLINK*)buylinks->physicals->elements[i];
        }
        else
        {
            buylink = (LASTFM_BUYLINK*)buylinks->downloads->elements[i-buylinks->physicals->size];
        }
    
        printf("type = %s\n", (buylink->type == LASTFM_BUYLINK_PHYSICAL) ? "physical" : "download");
        printf("supplierName = %s\n", buylink->supplierName);
        if(buylink->price != NULL)
        {
            printf("price = %f%s (%s)\n", buylink->price->amount, buylink->price->currency, buylink->price->formatted);
        }
        printf("buyLink = %s\n", buylink->buyLink);
        printf("supplierIcon = %s\n", buylink->supplierIcon);
        printf("isSearch = %d\n\n", buylink->isSearch);
    }
    
    shouts = album_getShouts("Kansas", "Kansas", NULL, 1, 20, false, auth);
    printf("artist = %s\nalbum = %s\npage = %d\nperPage = %d\ntotalPages = %d\ntotal = %d\n\n",
           shouts->artist, shouts->album, shouts->page, shouts->perPage, shouts->totalPages, shouts->total);
    for(i = 0; i < shouts->shouts->size; ++i)
    {
        LASTFM_SHOUT *shout;
        
        shout = (LASTFM_SHOUT*)shouts->shouts->elements[i];
    
        printf("body = %s\n", shout->body);
        printf("author = %s\n", shout->author);
        printf("date = %d:%d:%d %d/%d/%d\n\n", shout->date->tm_hour,
                                               shout->date->tm_min,
                                               shout->date->tm_sec,
                                               shout->date->tm_mday,
                                               shout->date->tm_mon,
                                               shout->date->tm_year + 1900);
    }
    
    lastfm_buylinks_delete(buylinks);
    lastfm_shouts_delete(shouts);
    lastfm_auth_delete(auth);
    lastfm_shutdown();

    return EXIT_SUCCESS;
}
